-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
--
-- (c) 2011 Peter Althainz
--
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
--
--     http://www.apache.org/licenses/LICENSE-2.0
--
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.

-- BaseAPI.hs

-- |This module includes the basic API of HGamer3D

module HGamer3D.BaseAPI

(
	module HGamer3D.Data.Colour,
	module HGamer3D.Data.Vector,
	module HGamer3D.Data.Angle,

	module HGamer3D.APIs.Base.Audio,
	module HGamer3D.APIs.Base.InputSystem,
	module HGamer3D.APIs.Base.Common,
	module HGamer3D.APIs.Base.Graphics3D.Engine3D,
	module HGamer3D.APIs.Base.Graphics3D.Light,
	module HGamer3D.APIs.Base.Graphics3D.Object3D,
	
	initHGamer3D

)

where

import HGamer3D.Data.Colour
import HGamer3D.Data.Vector
import HGamer3D.Data.Angle

import HGamer3D.APIs.Base.Audio
import HGamer3D.APIs.Base.InputSystem
import HGamer3D.APIs.Base.Common
import HGamer3D.APIs.Base.Graphics3D.Engine3D
import HGamer3D.APIs.Base.Graphics3D.Light
import HGamer3D.APIs.Base.Graphics3D.Object3D

import Control.Monad.Trans (liftIO)

initHGamer3D windowName = do
	cs <- initCommon
	es <- initEngine3D cs windowName "OctreeSceneManager"
	let s = [1..]
	return ((cs, es), s)
